/* 
 * Copyright (c) 2010 ISPRAS
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISPRAS)
 * 25 A.Solzhenitsyn st. Moscow 109004 Russia
 * http://hardware.ispras.ru
 *
 * All rights reserved.
 *
 * This source code is free software; you can redistribute it
 * and/or modify it in source code form under the terms of the GNU
 * General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 * $Id: error.h,v 1.4 2010/03/11 11:54:56 kamkin Exp $
 */

#ifndef _ERROR_H_INCLUDED_
#define _ERROR_H_INCLUDED_

#include <stdio.h>
#include <stdlib.h>

#define vt_format_error_and_exit(msg, options, ...)                            \
{                                                                              \
    fprintf(stderr, "%s: " msg "\n", (options)->application, __VA_ARGS__);     \
    exit(1);                                                                   \
}

#define vt_print_error_and_exit(msg, options)                                  \
{                                                                              \
    fprintf(stderr, "%s: %s\n", (options)->application, msg);                  \
    exit(1);                                                                   \
}

#endif // _ERROR_H_INCLUDED_
