/* 
 * Copyright (c) 2010 ISPRAS
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISPRAS)
 * 25 A.Solzhenitsyn st. Moscow 109004 Russia
 * http://hardware.ispras.ru
 *
 * All rights reserved.
 *
 * This source code is free software; you can redistribute it
 * and/or modify it in source code form under the terms of the GNU
 * General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 * $Id: common.h,v 1.2 2010/03/04 15:40:47 kamkin Exp $
 */

#ifndef _PRINTER_COMMON_H_INCLUDED_
#define _PRINTER_COMMON_H_INCLUDED_

#include <stdio.h>
#include <stdint.h>
#include <sys/types.h>

#include "../options.h"

void vt_print_decorated_comment(FILE *file, const char *comment, vt_options_t *options);
void vt_print_newline(FILE *file);
void vt_print_indent(FILE *file, int indent);

const char* vt_get_suitable_ctype(size_t width);
const char* vt_get_suitable_vtype(size_t width);

uint64_t vt_get_mask(size_t width);

unsigned vt_get_lo(uint64_t data);
unsigned vt_get_hi(uint64_t data);

#endif // _PRINTER_COMMON_H_INCLUDED_
