/* 
 * Copyright (c) 2010 ISPRAS
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISPRAS)
 * 25 A.Solzhenitsyn st. Moscow 109004 Russia
 * http://hardware.ispras.ru
 *
 * All rights reserved.
 *
 * This source code is free software; you can redistribute it
 * and/or modify it in source code form under the terms of the GNU
 * General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 * $Id: vpi_systf.h,v 1.3 2010/06/15 14:53:20 chupilko Exp $
 */

#ifndef _VPI_SYSTF_H_INCLUDED_
#define _VPI_SYSTF_H_INCLUDED_

//#define STARTSCEN_TEMPLATE                                                                                            \
    "    while(isblank(scen[0])) scen++;\n\n"                                                                         \
    "    /* Erase blank symbols at the begin of scen_params */\n"                                                     \
    "    int position = 0;\n"                                                                                         \
    "    while(isblank(scen_params[position])) position++;\n"                                                         \
    "        memmove(scen_params, scen_params + position, strlen(scen_params) - position + 1);\n\n"                   \
    "    /* This code looks for item in test registry where scenario is named *scen.\n"                               \
    "       Don't forget to create the registry! */\n"                                                                \
    "    int i;\n"                                                                                                    \
    "    for(i = 0; test_registry[i].testName; i++) {\n"                                                              \
    "        if(!strcmp(scen, test_registry[i].testName)) {\n"                                                        \
    "            int length_local = test_registry[i].testParams == NULL ? 0 : strlen(test_registry[i].testParams),\n" \
    "                length_global = strlen(scen_params);\n\n"                                                        \
    "            if(length_local > 0) {\n"                                                                            \
    "                assert(length_local + length_global < SCEN_ARGV_LENGTH - 1);\n"                                  \
    "                memmove(scen_params + length_local + 1, scen_params, length_global);\n"                          \
    "                memmove(scen_params, test_registry[i].testParams, length_local);\n"                              \
    "                scen_params[length_local] = \' \';\n"                                                            \
    "            }\n\n"                                                                                               \
    "            break;\n"                                                                                            \
    "        }\n"                                                                                                     \
    "    }\n\n"                                                                                                       \
    "    assert(test_registry[i].testName != NULL);\n"                                                                \
    "    assert(test_registry[i].testScenario != NULL);\n"                                                            \
    "    assert(test_registry[i].testEngine != NULL);\n\n"                                                            \
    "    if(test_registry[i].testType == CTESK) {\n"                                                                  \
    "        ctest = (TestScenario*)test_registry[i].testScenario;\n"                                                 \
    "        set_scenario_wrapper(ctest, test_registry[i].testEngine, scen_params, netscen);\n"                       \
    "        return start_scenario_with_wrapper(scenario_wrapper);\n"                                                 \
    "    }\n"                                                                                                         \
    "#ifdef __cplusplus\n"                                                                                            \
    "    else if(test_registry[i].testType == CPPTESK) {\n"                                                           \
    "        cpptest = ((cpptesk::ts::ScenarioBase*)test_registry[i].testScenario)->getTestScenario();\n"             \
    "        set_scenario_wrapper(cpptest, test_registry[i].testEngine, scen_params, netscen);\n"                     \
    "        return start_scenario_with_wrapper(scenario_wrapper_cpp);\n"                                             \
    "    }\n"                                                                                                         \
    "#endif // __cplusplus\n"                                                                                         \
    "    else {\n"                                                                                                    \
    "        assert(false);\n"                                                                                        \
    "    }\n"

#define VPI_SYSTF_TEMPLATE                                                              \
    "    s_vpi_value value;\n"                                                          \
    "    vpiHandle obj = vpi_handle(vpiSysTfCall, NULL);\n\n"                           \
    "    assert(obj != NULL);\n"                                                        \
    "    if(user_data == NULL) {} // TBD\n\n"                                           \
    "    if(obj != NULL)\n"                                                             \
    "    {\n"                                                                           \
    "        bool netscen = false;\n"                                                   \
    "        vpiHandle itr = vpi_iterate(vpiArgument, obj);\n\n"                        \
    "        vpiHandle arg = vpi_scan(itr);\n"                                          \
    "        value.format = vpiStringVal;\n"                                            \
    "        vpi_get_value(arg, &value);\n"                                             \
    "        if(*value.value.str == 1)\n"                                               \
    "            netscen = true;\n\n"                                                   \
    "        arg = vpi_scan(itr);\n"                                                    \
    "        vpi_get_value(arg, &value);\n"                                             \
    "        strcpy(scen_argv, value.value.str);\n\n"                                   \
    "        arg = vpi_scan(itr);\n"                                                    \
    "        vpi_get_value(arg, &value);\n\n"                                           \
    "        vpi_free_object(obj);\n"                                                   \
    "        vpi_free_object(itr);\n"                                                   \
    "        vpi_free_object(arg);\n\n"                                                 \
    "#ifdef __cplusplus\n"                                                              \
    "        return startscen_cpp_TestRegistry(netscen, value.value.str, scen_argv);\n" \
    "#else\n"                                                                           \
    "        return startscen_TestRegistry(netscen, value.value.str, scen_argv);\n"     \
    "#endif\n"                                                                          \
    "    }\n\n"                                                                         \
    "    return 0;\n"
    
#define VPI_SYSTF_TEMPLATE_CALL_TS                              \
    "    if(user_data == NULL) {} // TBD\n"                     \
    "    apply_check();\n"                                      \
    "    return 0;\n"                                           \

#include <assert.h>
#include <stdio.h>

#include "../design.h"
#include "../options.h"

void vt_print_vpi_systf_c(FILE *file, vt_design_t *design, vt_options_t *options);
void vt_print_vpi_systf_h(FILE *file, vt_design_t *design, vt_options_t *options);

#endif // _VPI_MEDIA_H_INCLUDED_
